unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Gauges, Grids, Math;


type
//=============================================================================
     Noeud=
        class
           private
              Fils    : array[32..255] of Noeud;  //liste de fils
              Lettre  : integer;     //lettre contenue dans ce noeud de l'arbre
              Entier  : boolean;     //flag indiquant si le mot est entier
              Etiquet : integer;     //flag indiquant si le mot est entier
           public
              constructor create ;
              destructor destroy ;
        end; { Noeud }

    //arbre d'ordre 26
    Arbre =
        class
           private
              tete : noeud ;
           public
              constructor create ;
              destructor destroy ;override ;
              procedure charger(NomFic : string) ;
              procedure rajouter_mot(LeMot : string;etiquet:integer;courant:Noeud) ;
              procedure fromStrings(chaines:Tstrings);//chaines are like word,etiquet
              function  Trouve(LeMot: string;courant:Noeud) : integer;
              function  toString(en_cours : noeud;trouve:string) : string;
              function  compter_terminaux(en_cours : noeud) : integer ;
        end ;
//=============================================================================

  TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    OuvrirTexte: TButton;
    OpenDialog1: TOpenDialog;
    Gauge1: TGauge;
    Found: TRichEdit;
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Frequencies: TRichEdit;
    Button2: TButton;
    StringGrid1: TStringGrid;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Nexus: TRichEdit;
    Antidico: TCheckBox;
    AntidicoWords: TRichEdit;
    Label2: TLabel;
    ColorR: TRichEdit;
    ColorG: TRichEdit;
    ColorB: TRichEdit;
    Font: TRichEdit;
    RichEdit3: TRichEdit;
    Color: TButton;
    OpenDialog2: TOpenDialog;
    OrderedTaxa: TListBox;
    Label3: TLabel;
    RadioGroup1: TRadioGroup;
    WindowLabel: TLabel;
    WindowSize: TEdit;
    NbFound: TRichEdit;
    AntiDicoWordsEng: TRichEdit;
    AntidicoENG: TCheckBox;
    Parametre: TLabel;
    ListBox3: TListBox;
    function elague(machin:string):string;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OuvrirTexteClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ColorClick(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  dico1,lantidico,lantidicoENG : arbre ;
  forbidden:array [1..50] of string;

implementation

{$R *.DFM}

function TForm1.elague (machin:string):string;
var
caract,chaine:string;
i:integer;
begin
i:=1;
while (i<50) and (forbidden[i]<>'') do
begin
   while pos(forbidden[i],machin)>0 do
   begin
      machin:=copy(machin,0,pos(forbidden[i],machin)-1)
              +' '+copy(machin,pos(forbidden[i],machin)+length(forbidden[i]),length(machin));
   end;
   inc(i);
end;

while pos(' ',machin)>0 do
begin
   machin:=copy(machin,0,pos(' ',machin)-1)
           +copy(machin,pos(' ',machin)+1,length(machin));
end;

result:=machin
end;

constructor noeud.create ;
var c : integer ;
begin
for c:=32 to 255 do
    fils[c]:=nil ;
lettre:=0;
etiquet:=0;
entier:=false;
end ;

destructor noeud.destroy ;
var c : integer ;
begin
for c:=32 to 255 do if fils[c]<>nil then fils[c].destroy ;
inherited destroy ;
end ;

constructor arbre.create ;
var i : integer ;
    c : integer ;
begin
tete:=noeud.create ;
end ;

destructor arbre.destroy ;
begin
tete.destroy ;
inherited destroy ;
end ;

procedure arbre.rajouter_mot(LeMot : string;etiquet:integer;courant:Noeud) ;
var lettre : integer ;
begin

if LeMot='' then
begin
   courant.entier:=true;
   courant.etiquet:=etiquet;
   exit ;
end;

lettre:=Ord(LeMot[1]);
if (courant.fils[lettre]=nil) then  //il faut crer cette lettre dans l'arbre
begin
   courant.fils[lettre]:=noeud.create ;
   courant.lettre:=lettre ;  // la lettre est maintenant dans l'arbre
end ;
delete(LeMot,1,1) ;  // on efface la lettre du mot puisqu'elle est dj dans l'arbre
rajouter_mot(LeMot,etiquet,courant.fils[lettre]) ; // et on rajoute le reste
end ;

procedure arbre.charger(NomFic : string) ;
var   s,chemin : string ;
       f : textfile ;
begin
// chargement du dico
chemin:=ExtractFilePath(Application.ExeName); {le chemin de l'appli, AVEC l'antislash final}
assignFile(f,chemin+nomFic) ;
reset(f) ;
repeat
    readln(f,s) ;
    rajouter_mot(s,0,tete) ;  // et on rajoute le mot
until eof(f) ;
closeFile(f) ;
end ;


function arbre.trouve(LeMot : string;courant:Noeud) : integer ;
var lettre : integer ;
begin
trouve:=-1;
if LeMot='' then  //--- incomplet ; tester aussi "entier"
   if courant.Entier then
       trouve:=courant.etiquet
   else
       trouve:=-1
else
   begin
   lettre:=Ord(LeMot[1]);
   delete(LeMot,1,1) ;

   if (lettre>31) and (lettre<256) then
   if (courant.fils[lettre]=nil) then
      trouve:=-1
   else
      begin
      trouve:=trouve(LeMot,courant.fils[lettre]) ;
      end ;
   end ;
end ;

function arbre.compter_terminaux(en_cours : noeud) : integer ;
var i     : integer ;
    total : integer ;
begin  // fonction valable aussi pour un arbre non quilibr
total:=0 ;
for i:=32 to 255 do
begin
    if en_cours.fils[i]<>nil then
       inc(total,compter_terminaux(en_cours.fils[i])) ;
end;
if total=0 then inc(total) ;
compter_terminaux:=total ;
end ;

{
function arbre.toString(en_cours : noeud) : string ;
var
i:integer;
chaine:string;
c1,c2,c3:string;
begin
chaine:='';
if en_cours.Entier then c1:='1' else c1:='0';
chaine:=chaine+('['+Chr(en_cours.Lettre)+','+c1+','+inttostr(en_cours.Etiquet)+'](');
for i:=32 to 255 do
begin
    if en_cours.fils[i]<>nil then
    begin
       chaine:=chaine+toString(en_cours.fils[i]);
    end;
end;
chaine:=chaine+')';
result:=chaine;
end ;
}


procedure arbre.fromStrings(chaines:Tstrings);//chaines are like word,etiquet
var
i:integer;
chaine:string;
c1,c2,c3:string;
begin

for i:=0 to chaines.Count-1 do
begin
   rajouter_mot(copy(chaines.Strings[i],0,pos(',',chaines.Strings[i])-1),
   strtoint(copy(chaines.Strings[i],pos(',',chaines.Strings[i])+1,length(chaines.Strings[i]))),tete)
end;
end;


function arbre.toString(en_cours : noeud;trouve:string) : string ;
var
i:integer;
chaine:string;
c1,c2,c3:string;
begin

if en_cours.Entier then
begin
   chaine:=trouve+','+inttostr(en_cours.etiquet)+',';
end;

for i:=32 to 255 do
begin
    if en_cours.fils[i]<>nil then
    begin
       //showmessage(inttostr(en_cours.etiquet)+' '+trouve+'='+trouve+chr(i));
       chaine:=chaine+toString(en_cours.fils[i],trouve+chr(i));
    end;
end;
result:=chaine;
end ;


//=============================================================================

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
begin
dico1:=arbre.create ;
forbidden[1]:=',';
forbidden[2]:=';';
forbidden[3]:='.';
forbidden[4]:='(';
forbidden[5]:=')';
forbidden[6]:=':';
forbidden[7]:='?';
forbidden[8]:='!';
forbidden[9]:='/';
forbidden[10]:='-';
forbidden[11]:='_';
forbidden[12]:='''';
forbidden[13]:='`';
forbidden[14]:='';
forbidden[15]:='';
forbidden[16]:='';
forbidden[17]:='';
forbidden[18]:='"';
forbidden[19]:='[';
forbidden[20]:=']';
forbidden[21]:='{';
forbidden[22]:='}';
forbidden[23]:=char(9);
forbidden[24]:='';
forbidden[25]:='';
forbidden[26]:='';
forbidden[27]:='';
forbidden[28]:='';
forbidden[29]:='';
forbidden[30]:='';
lantidico:=arbre.create ;
lantidicoENG:=arbre.create ;
for i:=0 to antidicoWords.Lines.count-1 do
begin
   lantidico.rajouter_mot(lowercase(antidicoWords.lines[i]),0,lantidico.tete);
end;
for i:=0 to antidicoWordsENG.Lines.count-1 do
begin
   lantidicoENG.rajouter_mot(lowercase(antidicoWordsENG.lines[i]),0,lantidicoENG.tete);
end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
Dico1.Destroy;
end;


procedure TForm1.OuvrirTexteClick(Sender: TObject);
var
nbwords,size,i,j,isfound:integer;
temp,chaine:string;
begin
if opendialog1.Execute then
begin
OuvrirTexte.Enabled:=false;
richedit1.Lines.loadfromfile(opendialog1.FileName);

size:=0;
nbwords:=0;
gauge1.MaxValue:=richedit1.Lines.count;
gauge1.MinValue:=0;
for i:=0 to richedit1.lines.count-1 do
begin

   gauge1.progress:=i+1;
   chaine := richedit1.lines[i];
   while pos(' ',chaine)>0 do
   begin
      inc(nbwords);
      temp:=lowercase(elague(copy(chaine,0,pos(' ',chaine)-1)));
      isfound:=dico1.trouve(temp,dico1.tete);
      if isfound=-1 then
      begin
          dico1.rajouter_mot(temp,size,dico1.tete);
          inc(size);
          found.Lines.add(inttostr(nbwords)+',');
          nbfound.Lines.add('1');
      end
      else
      begin
          found.Lines[isfound]:=found.Lines[isfound]+(inttostr(nbwords))+',';
          nbfound.Lines[isfound]:=inttostr(strtoint(nbfound.Lines[isfound])+1);
      end;
      chaine := copy(chaine,pos(' ',chaine)+1,length(chaine));
   end;

end;

richedit1.lines.clear;

edit1.Text:=inttostr(1+Math.floor(nbwords/Math.LnXP1(size-1)/100));
chaine:=dico1.toString(dico1.tete,'');
while pos(',',chaine)>0 do
begin
   temp:=copy(chaine,0,pos(',',chaine));
   chaine:=copy(chaine,pos(',',chaine)+1,length(chaine));
   temp:=temp+copy(chaine,0,pos(',',chaine)-1);
   chaine:=copy(chaine,pos(',',chaine)+1,length(chaine));
   richedit1.Lines.add(temp);
end;

//showmessage(inttostr(length(dico1.toString(dico1.tete))));
//showmessage(inttostr(dico1.compter_terminaux(dico1.tete)))
end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
mot:string;
ref,i,j,nbvirg:integer;
begin
i:=0;
Frequencies.lines.clear;
Frequencies.lines.add(' ; ');
gauge1.MinValue:=0;

while i<richedit1.Lines.count do
begin
   gauge1.MaxValue:=Frequencies.Lines.count;
   gauge1.progress:=1+i;

   ref:=strtoint(copy(richedit1.Lines[i],
   1+pos(',',richedit1.Lines[i]),
   length(richedit1.Lines[i])));
   mot:=copy(richedit1.Lines[i],0,pos(',',richedit1.Lines[i])-1);
   j:=1;
   nbvirg:=strtoint(nbfound.lines[ref]);
   if nbvirg<strtoint(edit1.Text) then
   begin
      found.lines[ref]:='';
      richedit1.Lines.delete(i);
   end
   else
   begin
      if ((antidico.Checked) and ((mot='') or (lantidico.Trouve(mot,lantidico.tete)>-1))) or
      ((antidicoENG.Checked) and ((mot='') or (lantidicoENG.Trouve(mot,lantidicoENG.tete)>-1))) then
      begin
         found.lines[ref]:='';
         richedit1.Lines.delete(i);
      end
      else
      begin
         Frequencies.lines.add(
         copy(richedit1.Lines[i],0,1+pos(',',richedit1.Lines[i])-2)
         +';'+inttostr(nbvirg)
         );
         inc(i);
      end;
   end;
end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
minii,minjj,i,j,ii,jj,ci,cj,ref,mindist,compteur,window,n12,n21,n1,n2:integer;
totdist:real;
chaine,temp,ligne:string;
begin
StringGrid1.ColCount:=richedit1.Lines.Count+1;
StringGrid1.RowCount:=richedit1.Lines.Count+1;
gauge1.MinValue:=0;
gauge1.MaxValue:=richedit1.lines.count;

for i:=0 to richedit1.lines.count-1 do
begin
   gauge1.progress:=1+i;
   Stringgrid1.Cells[0,i+1]:=copy(richedit1.lines[i],0,pos(',',richedit1.lines[i])-1);
   Stringgrid1.Cells[i+1,0]:=Stringgrid1.Cells[0,i+1];
   Stringgrid1.Cells[i+1,i+1]:='0';

   ref:=strtoint(copy(richedit1.Lines[i],
   1+pos(',',richedit1.Lines[i]),
   length(richedit1.Lines[i])));
   listbox1.Items.Clear;
   chaine:=found.lines[ref];
   n1:=0;
   ci:=1;
   temp:='';

   while ci<=length(chaine) do
   begin
      if chaine[ci]<>',' then
         temp:=temp+chaine[ci]
      else
      begin
         listbox1.Items.add(temp);
         temp:='';
         inc(n1);
      end;
      inc(ci);
   end;
   listbox3.Items:=listbox1.items;
   for j:=0 to richedit1.Lines.Count-1 do
   begin
      //compute min distance between i and j
      listbox2.clear;
      ref:=strtoint(copy(richedit1.Lines[j],
      1+pos(',',richedit1.Lines[j]),
      length(richedit1.Lines[j])));
      listbox2.Items.Clear;
      chaine:=found.lines[ref];
      n2:=0;

      cj:=1;
      temp:='';
      while cj<=length(chaine) do
      begin
         if chaine[cj]<>',' then
            temp:=temp+chaine[cj]
         else
         begin
            listbox2.Items.add(temp);
            temp:='';
            inc(n2);
         end;
         inc(cj);
      end;
      if radiogroup1.ItemIndex=1 then
      begin
      //compute cooccurence distance between word1 and word2
      window:=Math.floor(strtoint(Windowsize.Text)/2);
      ii:=0;
      jj:=0;
      n12:=0;

      while (ii<listbox1.Items.count) and (jj<listbox2.Items.count) do
      begin
         if strtoint(listbox2.items[jj])<window+strtoint(listbox1.items[ii]) then
         begin
            if strtoint(listbox2.items[jj])<strtoint(listbox1.items[ii])-window then
               inc(jj)
            else
            begin
               inc(ii);
               n12:=n12+1;
            end;
         end
         else
         begin
            inc(ii);
         end;
      end;
      n21:=0;
      while (ii<listbox2.Items.count) and (jj<listbox1.Items.count) do
      begin
         if strtoint(listbox1.items[jj])<window+strtoint(listbox2.items[ii]) then
         begin
            if strtoint(listbox1.items[jj])<strtoint(listbox2.items[ii])-window then
               inc(jj)
            else
            begin
               inc(ii);
               n21:=n21+1;
            end;
         end
         else
         begin
            inc(ii);
         end;
      end;
      //stringgrid1.Cells[i+1,j+1]:=floattostr(1-max(n12/n1,n21/n2));
      //stringgrid1.Cells[i+1,j+1]:=floattostr(Math.Log2(1+Math.Log2(101))-(Math.Log2(1+Math.Log2(1+max(100*n12/n1,100*n21/n2)))));

      if (n1>0) and (n2>0) then
         stringgrid1.Cells[i+1,j+1]:=floattostr(Math.Log2(101)-(Math.Log2(1+max(100*n12/n1,100*n21/n2))))
      else
         stringgrid1.Cells[i+1,j+1]:=floattostr(Math.Log2(101));
      stringgrid1.Cells[j+1,i+1]:=stringgrid1.Cells[i+1,j+1];
      end
      else
      begin
      //compute minimum text distance between word1 and word2
      totdist:=0;
      listbox1.Items:=listbox3.items;
      for compteur:=1 to min(1,strtoint(WindowSize.text)) do
      begin
         ii:=0; minii:=0;
         jj:=0; minjj:=0;
         //showmessage(inttostr(listbox1.items.count)+' '+inttostr(listbox2.items.count));
         mindist:=abs(strtoint(listbox1.items[ii])-strtoint(listbox2.items[jj]));
         while (ii<listbox1.Items.count) and (jj<listbox2.Items.count) do
         begin
            if abs(strtoint(listbox1.items[ii])-strtoint(listbox2.items[jj]))<mindist then
            begin
               mindist:=abs(strtoint(listbox1.items[ii])-strtoint(listbox2.items[jj]));
               minii:=ii;
               minjj:=jj;
            end;
            if strtoint(listbox1.items[ii])<strtoint(listbox2.items[jj]) then
               inc(ii)
            else
               inc(jj);
         end;
         listbox1.Items.Delete(minii);
         listbox2.Items.Delete(minjj);         
         totdist:=totdist+mindist;
      end;
      stringgrid1.Cells[i+1,j+1]:=floattostr(Math.Log2(totdist+1));
      stringgrid1.Cells[j+1,i+1]:=floattostr(Math.Log2(totdist+1));
      end;
   end;
end;

{
//UPGMA
nexus.Lines.clear;



}


//Nexus !
nexus.Lines.clear;
nexus.lines.add('#nexus');
nexus.lines.add(' ');
nexus.lines.add('BEGIN Taxa;');
nexus.lines.add('DIMENSIONS ntax='+inttostr(Stringgrid1.ColCount-1)+';');
nexus.lines.add('TAXLABELS');
for i:=1 to Stringgrid1.ColCount-1 do
begin
    ligne:=Stringgrid1.Cells[0,i];
    while pos('''',ligne)>0 do
       ligne:=copy(ligne,0,pos('''',ligne)-1)+' '+copy(ligne,pos('''',ligne)+1,length(ligne));
    if length(ligne)>13 then
        ligne:=copy(ligne,1,12);
    nexus.lines.add('['+inttostr(i)+'] '''+ligne+'''');
end;
nexus.lines.add('; ');
nexus.lines.add('END; [Taxa]');
nexus.lines.add('BEGIN Distances;');
nexus.lines.add('DIMENSIONS ntax='+inttostr(Stringgrid1.ColCount-1)+';');
nexus.lines.add('FORMAT labels=left diagonal triangle=both;');
nexus.lines.add('MATRIX');

for i:=1 to Stringgrid1.ColCount-1 do
begin
    ligne:=Stringgrid1.Cells[0,i];
    while pos('''',ligne)>0 do
       ligne:=copy(ligne,0,pos('''',ligne)-1)+' '+copy(ligne,pos('''',ligne)+1,length(ligne));
    if length(ligne)>13 then
        ligne:=copy(ligne,1,12);
    ligne:=''''+ligne+'''';
    while length(ligne)<15 do
        ligne:=ligne+' ';
    ligne:='['+inttostr(i)+'] '+ligne;

    for j:=1 to Stringgrid1.ColCount-1 do
    begin
        chaine := StringGrid1.Cells[i,j];
        while pos(',',chaine)>0 do
           chaine:=copy(chaine,0,pos(',',chaine)-1)+'.'+copy(chaine,pos(',',chaine)+1,length(chaine));
        ligne := ligne+' '+chaine;
    end;
    nexus.lines.add(ligne);
end ;
nexus.lines.add(';');
nexus.lines.add('END; [Distances]');
end;

procedure TForm1.ColorClick(Sender: TObject);
var
minii,minjj,min,max,nombre,i,j,ref,numero,importance,level:integer;
chaine:string;
begin
If opendialog2.execute then
begin
   max:=0;
   min:=strtoint(copy(frequencies.lines[1],pos(';',frequencies.lines[1])+1,length(frequencies.lines[1])));;
   for i:=1 to Frequencies.lines.count-1 do
   begin
      importance:=strtoint(copy(frequencies.lines[i],pos(';',frequencies.lines[i])+1,length(frequencies.lines[i])));
      if importance>max then
         max := importance;
      if importance<min then
         min := importance;
   end;
   //showmessage(inttostr(min)+' '+inttostr(max));

   nexus.lines.loadfromfile(opendialog2.FileName);
   i:=0;
   while i<nexus.lines.count do
   begin
      OrderedTaxa.items.add(' ');
      inc(i);
   end;
   i:=0;
   while (i<nexus.Lines.count) and (nexus.lines[i]<>'BEGIN Trees;') do
   begin
      inc(i);
   end;

   while (i<nexus.Lines.count) and (nexus.lines[i]<>'END; [Trees]') do
   begin
      nexus.lines.Delete(i);
   end;
   nexus.lines.Delete(i);

   while (i<nexus.Lines.count) and (nexus.lines[i]<>'TRANSLATE') do
   begin
      inc(i);
   end;
   inc(i);
   //showmessage('found TRANSLATE at line '+inttostr(i));

   while (i<nexus.Lines.count) and (nexus.lines[i]<>';') do
   begin
      nombre:=strtoint(copy(nexus.lines[i],1,pos(' ',nexus.lines[i])-1));
      //showmessage('nombre '+inttostr(nombre)+'<'+inttostr(OrderedTaxa.Lines.Count+1));

      chaine:=copy(nexus.lines[i],pos('''',nexus.lines[i])+1,length(nexus.lines[i]));
      chaine:=copy(chaine,0,pos('''',chaine)-1);

      for j:=1 to Stringgrid1.ColCount-1 do
      begin
         if Stringgrid1.Cells[0,j]=chaine then
         begin
             //showmessage('-'+Stringgrid1.Cells[0,j]+'-'+chaine+'-'+inttostr(j));
             OrderedTaxa.items[nombre]:=inttostr(j);
             //showmessage(OrderedTaxa.items[nombre]);
         end;
      end;
      inc(i);
   end;

   while (i<nexus.Lines.count) and (nexus.lines[i]<>'VERTICES') do
   begin
      inc(i);
   end;
   inc(i);

   while (i<nexus.Lines.count) and (nexus.lines[i]<>';') do
   begin
      numero:=strtoint(copy(nexus.lines[i],1,pos(' ',nexus.lines[i])-1));
      if OrderedTaxa.Items[numero]<>' ' then
      begin
         //Go search the frequency of the taxa
         nombre:=strtoint(OrderedTaxa.items[numero]);
         importance:=strtoint(copy(frequencies.lines[nombre],pos(';',frequencies.lines[nombre])+1,length(frequencies.lines[nombre])));
         level:=Math.floor(1+9.99999*((math.log2(importance)-math.log2(min))/(math.log2(max)-math.log2(min))));
         nexus.lines[i]:=copy(nexus.lines[i],0,pos('s=n',nexus.lines[i])+2)+
         ' c='+colorR.lines[level]+' '+colorG.lines[level]+' '+colorB.lines[level]+
         ' b='+colorR.lines[level]+' '+colorG.lines[level]+' '+colorB.lines[level]+',';
      end;
      inc(i);
   end;

   while (i<nexus.Lines.count) and (nexus.lines[i]<>'VLABELS') do
   begin
      inc(i);
   end;
   inc(i);

   while (i<nexus.Lines.count) and (nexus.lines[i]<>';') do
   begin
      numero:=strtoint(copy(nexus.lines[i],1,pos(' ',nexus.lines[i])-1));
      if OrderedTaxa.Items[numero]<>' ' then
      begin
         //Go search the frequency of the taxa
         nombre:=strtoint(OrderedTaxa.items[numero]);
         importance:=strtoint(copy(frequencies.lines[nombre],pos(';',frequencies.lines[nombre])+1,length(frequencies.lines[nombre])));
         level:=Math.floor(1+9.99999*((math.log2(importance)-math.log2(min))/(math.log2(max)-math.log2(min))));
         nexus.lines[i]:=copy(nexus.lines[i],0,pos('f=''',nexus.lines[i])+1)+
         Font.Lines[level]+',';
      end;
      inc(i);
   end;


end;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
if radioGroup1.ItemIndex=0 then
begin
   windowSize.text:='3';
   windowLabel.visible:=false;
end
else
begin
   windowSize.text:='20';
   windowLabel.Visible:=true;
end;
end;

end.
